/*
 * REVERSERAIDER.H
 *
 * ReverseRaider, domain scanner.
 * Copyright (C) 2008  Acri Emanuele <crossbower@gmail.com>
 * 
 * From an idea of Jeremy Brown --- http://jbrownsec.blogspot.com/
 *
 * Thanks to:
 * Martin Holst Swende <martin.holst_swende@msc.se>
 * for wordlistscanner() function
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef __REVERSERAIDER_H__
#define __REVERSERAIDER_H__ 

#include "argparser.h"

#include <stdlib.h>

#include <sys/types.h>
#include <sys/socket.h>
#include <arpa/inet.h>

#include <netdb.h>
#include <ares.h>
#include <ares_dns.h>

/*
 * Callback function
 */
static void callback(void *arg, int status, int timeouts, struct hostent *host);

/*
 * Prepare ares options and mask for ares_init_options()
 */
void prep_ares_opt(struct options *opt, struct ares_options *options, int *optmask);

/*
 * Brute force wordlist scanner
 */
void wordlistscanner(struct options *opt);

/*
 * Reverse resolution scanner
 */
void reversescanner(struct options *opt);

/*
 * Program init
 */
int main(int argc, char **argv);

#endif /* __REVERSERAIDER_H__ */

